

tinsert(UIMenus, "GupPet_InterfaceFrame");


--------------------------------------------------------------------------------------------------------------
--	Popups							 																		--
--------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------
StaticPopupDialogs["GupPet_Interface_Remove"] = {
  text = GUPPET_L["POPUP_REMOVE"] ,
  button1 = GUPPET_L["POPUP_REMOVEYES"],
  button2 = GUPPET_L["POPUP_REMOVENO"],
  OnAccept = function()
        local selected = GupPet_InterfaceLocationList_GetSelected() ;
							
		if GupPet_DataHandler_RemoveLocation(selected.Name) > 0 then
			GupPet_InterfaceCompanion_LocationFrame_Update();
			GupPet_InterfaceLocatinList_SetSelected( selected.Index-1 ) ;
		end
  end,
  timeout = 0,
  whileDead = 1,
  hideOnEscape = 1
};

StaticPopupDialogs["GupPet_Interface_ChangeStyle"] = {
  text = GUPPET_L["POPUP_CHANGESTYLE"] ,
  button1 = GUPPET_L["POPUP_CHANGESTYLEYES"],
  button2 = GUPPET_L["POPUP_CHANGESTYLENO"],
  OnAccept = function()
        
		if GupPet_SavedOptions["Style"] == "CheckBox" then
			GupPet_SavedOptions["Style"] = "Slider";
		else
			GupPet_SavedOptions["Style"] = "CheckBox";
		end
		ReloadUI() ;
  end,
  OnCancel = function()
 		GupPet_InterfaceFrameOptions.ExtraFrame.Style:SetChecked( not(GupPet_SavedOptions["Style"] == "CheckBox" )  ); 
  end,
  timeout = 0,
  whileDead = 1,
  hideOnEscape = 1
};


----------------------------------------------------------------------------------------------------------------
--[[	GupPet_Interface_MakeButtons		 																	]]--
----------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------
function GupPet_Interface_MakeButtons()
 
	local Optionframe = CreateFrame( "Frame", "GupPetetPanel" , nil ); 
	Optionframe.name = "GupPet";
		
	local Optionframe_Button = CreateFrame("Button", "GupPet_OptionButton", Optionframe , "GupPet_InterfaceButtonTemplate");
	Optionframe_Button:SetScript("OnClick", function ()  ShowUIPanel(GupPet_InterfaceFrame); end) ;
	Optionframe_Button:SetWidth(200); 
	Optionframe_Button:SetHeight(30); 
	Optionframe_Button:SetPoint("CENTER", 0, 0);
	Optionframe_Button:SetText( "GupPet" );
	 
	InterfaceOptions_AddCategory(Optionframe);
end


----------------------------------------------------------------------------------------------------------------
--[[ 	GupPet_InterfaceFrame_OnShow																			]]--
----------------------------------------------------------------------------------------------------------------
function GupPet_InterfaceFrame_OnShow(self)

	-- Do Stuf at first Show 
	if not self.Shown then
		self.Shown = 1 ;
	
		GupPet_Interface_ShowTab( _G["GupPet_InterfaceFrameOptionsTab"] ) ;
	
	end



end

----------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------

----------------------------------------------------------------------------------------------------------------
--[[ 	GupPet_InterfaceOptionsFrame_OnShow																	]]--
----------------------------------------------------------------------------------------------------------------
function GupPet_InterfaceOptionsFrame_OnShow(self)

	-- Do Stuf at first Show 
	if not self.Shown then
		self.Shown = 1 ;
	
		----------------------------------------------------------------------------
		----------------------------------------------------------------------------
		--IngameButtonsFrame
		self.IngameButtonFrame = CreateFrame("FRAME", "$parentIngameButtonFrame", self , "GupPet_InterfaceFrameTitlePartTemplate");
 		self.IngameButtonFrame:SetWidth(240);
		self.IngameButtonFrame:SetHeight(165);	
		self.IngameButtonFrame:SetPoint("TOPLEFT", 10 , -30);
		self.IngameButtonFrame.Title:SetText( "|cFFFC830E".. GUPPET_L["INGAMEBUTTONFRAME"] );
	
		self.IngameButtonFrame.Show = CreateFrame("CheckButton", "$parentShow"  , self.IngameButtonFrame , "GupPet_InterfaceSmallCheckButtonTemplate");
		self.IngameButtonFrame.Show:SetPoint("TOPLEFT", 10, -10 );
		self.IngameButtonFrame.Show:SetChecked( GupPet_SavedOptions["IngameButton"]["Show"] ); 
		self.IngameButtonFrame.Show:SetScript("OnClick", function (self, button, down) GupPet_SavedOptions["IngameButton"]["Show"]=self:GetChecked();  GupPet_IngameButtons_Update();   end);
		self.IngameButtonFrame.Show.text:SetText( GUPPET_L["INGAMEBUTTONFRAME_SHOW"] );

		self.IngameButtonFrame.Locked = CreateFrame("CheckButton", "$parentLocked"  , self.IngameButtonFrame , "GupPet_InterfaceCheckButtonTemplate");
		self.IngameButtonFrame.Locked:SetPoint("TOPLEFT", 20, -32 );
		self.IngameButtonFrame.Locked:SetChecked( GupPet_SavedOptions["IngameButton"]["Lock"] ); 
		self.IngameButtonFrame.Locked:SetScript("OnClick", function (self, button, down)  GupPet_SavedOptions["IngameButton"]["Lock"]=self:GetChecked();  GupPet_IngameButtons_UpdateDrag();   end);
		self.IngameButtonFrame.Locked.text:SetText( GUPPET_L["INGAMEBUTTONFRAME_LOCKED"] );
	
		self.IngameButtonFrame.Restore = CreateFrame("Button", "$parentRestore", self.IngameButtonFrame , "GupPet_InterfaceButtonTemplate");
		self.IngameButtonFrame.Restore:SetScript("OnClick", function () GupPet_IngameButtons_DragReset();   end) ; -- Trow it back to the center
		self.IngameButtonFrame.Restore:SetWidth(75); 
		self.IngameButtonFrame.Restore:SetHeight(15); 
		self.IngameButtonFrame.Restore:SetPoint("TOPRIGHT",-10, -32);
		self.IngameButtonFrame.Restore:SetText( GUPPET_L["INGAMEBUTTONFRAME_RESTORE"] );
		self.IngameButtonFrame.Restore.tooltipText = GUPPET_L["INGAMEBUTTONFRAME_RESTORETOOLTIP"] ;
		self.IngameButtonFrame.Restore:SetNormalFontObject( GupPet_FontText);
		self.IngameButtonFrame.Restore:SetHighlightFontObject( GupPet_FontText);

	--[[
		GUPPET_INTERFACE_OPTIONFRAME.Icon = CreateFrame("Button", "GupPetet_Restore", GUPPET_INTERFACE_OPTIONFRAME.IngameButtonFrame , "GupPetet_ButtonTemplate");
		GUPPET_INTERFACE_OPTIONFRAME.Icon:SetScript("OnClick", function ()  if GupPetet_IconPopupFrame:IsShown() then GupPetet_IconPopupFrame:Hide() else GupPetet_IconPopupFrame:Show() end end) ;
		GUPPET_INTERFACE_OPTIONFRAME.Icon:SetWidth(75); 
		GUPPET_INTERFACE_OPTIONFRAME.Icon:SetHeight(15); 
		GUPPET_INTERFACE_OPTIONFRAME.Icon:SetPoint("TOPRIGHT",-10, -15);
		GUPPET_INTERFACE_OPTIONFRAME.Icon:SetText( GUPPET_L["ICON"][1] );
		GUPPET_INTERFACE_OPTIONFRAME.Icon.tooltipText = GUPPET_L["ICON"][2];
		GUPPET_INTERFACE_OPTIONFRAME.Icon:SetNormalFontObject( GupPetet_FontText);
		GUPPET_INTERFACE_OPTIONFRAME.Icon:SetHighlightFontObject( GupPetet_FontText);
	]]	
		
		self.IngameButtonFrame.ButtonMode = CreateFrame("CheckButton", "$parentButtonMode"  , self.IngameButtonFrame, "GupPet_InterfaceCheckButtonTemplate");
		self.IngameButtonFrame.ButtonMode:SetPoint("TOPLEFT", 20, -47 );
		self.IngameButtonFrame.ButtonMode:SetScript("OnClick", function (self, button, down)  if self:GetChecked() then GupPet_SavedOptions.IngameButton.MountButton = "Auto"   else GupPet_SavedOptions.IngameButton.MountButton = "Hand"  end ; GupPet_IngameButtons_Update(); end);
		self.IngameButtonFrame.ButtonMode:SetChecked(  GupPet_SavedOptions.IngameButton.MountButton == "Auto" ); 
		self.IngameButtonFrame.ButtonMode.text:SetText( GUPPET_L["INGAMEBUTTONFRAME_MODE"]  ) ;
		self.IngameButtonFrame.ButtonMode.tooltipText = GUPPET_L["INGAMEBUTTONFRAME_MODETOOLTIP"] ;	
		
		self.IngameButtonFrame.CompanionButtonShow = CreateFrame("CheckButton", "$parentCompanionButtonShow"  , self.IngameButtonFrame, "GupPet_InterfaceCheckButtonTemplate");
		self.IngameButtonFrame.CompanionButtonShow:SetPoint("TOPLEFT", 20, -62 );
		self.IngameButtonFrame.CompanionButtonShow:SetScript("OnClick", function (self, button, down)   GupPet_SavedOptions.IngameButton.CompanionButton = self:GetChecked() ;  GupPet_IngameButtons_Update();  end);
		self.IngameButtonFrame.CompanionButtonShow:SetChecked( GupPet_SavedOptions["IngameButton"]["CompanionButton"] ); 
		self.IngameButtonFrame.CompanionButtonShow.text:SetText( GUPPET_L["INGAMEBUTTONFRAME_COMPANIONBUTTONSHOW"]  ) ;
		
		self.IngameButtonFrame.ButtonAlignment = CreateFrame("CheckButton", "$parentButtonAlignment"  , self.IngameButtonFrame, "GupPet_InterfaceCheckButtonTemplate");
		self.IngameButtonFrame.ButtonAlignment:SetPoint("TOPLEFT", 20, -77 );
		self.IngameButtonFrame.ButtonAlignment:SetScript("OnClick", function (self, button, down)  if self:GetChecked() then GupPet_SavedOptions.IngameButton.Alignment = "Vertical"   else GupPet_SavedOptions.IngameButton.Alignment = "Horizontal"  end ; GupPet_IngameButtons_Update(); end);
		self.IngameButtonFrame.ButtonAlignment:SetChecked(  GupPet_SavedOptions.IngameButton.Alignment == "Vertical"); 
		self.IngameButtonFrame.ButtonAlignment.text:SetText( GUPPET_L["INGAMEBUTTONFRAME_ALIGNMENT"]  ) ;
		self.IngameButtonFrame.ButtonAlignment.tooltipText = GUPPET_L["INGAMEBUTTONFRAME_ALIGNMENTTOOLTIP"] ;	
		
		self.IngameButtonFrame.ButtonHideKeyBind = CreateFrame("CheckButton", "$parentButtonHideKeyBind"  , self.IngameButtonFrame, "GupPet_InterfaceCheckButtonTemplate");
		self.IngameButtonFrame.ButtonHideKeyBind:SetPoint("TOPLEFT", 20, -92 );
		self.IngameButtonFrame.ButtonHideKeyBind:SetScript("OnClick", function (self, button, down)  if self:GetChecked() then GupPet_SavedOptions.IngameButton.HideKeyBind = true; else GupPet_SavedOptions.IngameButton.HideKeyBind = nil;  end  GupPet_OnEvent(self, "UPDATE_BINDINGS");  end);
		self.IngameButtonFrame.ButtonHideKeyBind:SetChecked(  GupPet_SavedOptions.IngameButton.HideKeyBind ); 
		self.IngameButtonFrame.ButtonHideKeyBind.text:SetText( GUPPET_L["INGAMEBUTTONFRAME_HIDEKEYBINDTEXT"]  ) ;
		self.IngameButtonFrame.ButtonHideKeyBind.tooltipText = GUPPET_L["INGAMEBUTTONFRAME_HIDEKEYBINDTEXTTOOLTIP"] ;	
		
		self.IngameButtonFrame.Scale = CreateFrame('Slider', "$parentScale", self.IngameButtonFrame , 'GupPet_InterfaceBigSliderTemplate');
		self.IngameButtonFrame.Scale:SetPoint('TOP', 0, -130); 
		self.IngameButtonFrame.Scale:SetOrientation('HORIZONTAL');
		self.IngameButtonFrame.Scale:SetWidth(160) ;
		self.IngameButtonFrame.Scale:SetHeight(17);
		self.IngameButtonFrame.Scale:SetMinMaxValues(0.2 , 2.5 );
		self.IngameButtonFrame.Scale:SetValueStep(0.05) ;
		self.IngameButtonFrame.Scale:SetValue( GupPet_SavedOptions["IngameButton"]["Scale"] );
		self.IngameButtonFrame.Scale:SetScript("OnValueChanged", function (self)   GupPet_SavedOptions["IngameButton"]["Scale"] = self:GetValue() ;  GupPet_IngameButtonFrame:SetScale( GupPet_SavedOptions.IngameButton.Scale );      end);
		self.IngameButtonFrame.Scale.text:SetText(GUPPET_L["INGAMEBUTTONFRAME_SCALE"]) ;
		self.IngameButtonFrame.Scale.low:SetText(GUPPET_L["INGAMEBUTTONFRAME_SCALELOW"]) ;
		self.IngameButtonFrame.Scale.high:SetText(GUPPET_L["INGAMEBUTTONFRAME_SCALEHIGH"]) ;
		
		----------------------------------------------------------------------------
		----------------------------------------------------------------------------
		-- AutoCritter
		self.AutoCallCompanionFrame = CreateFrame("FRAME", "$parentAutoCallCompanionFrame", self , "GupPet_InterfaceFrameTitlePartTemplate");
 		self.AutoCallCompanionFrame:SetWidth(220);
		self.AutoCallCompanionFrame:SetHeight(300);	
		self.AutoCallCompanionFrame:SetPoint("TOPLEFT", 260 , -30);
		self.AutoCallCompanionFrame.Title:SetText( "|cFFFC830E".. GUPPET_L["AUTOCALLCOMPANIONFRAME"] );
	
		self.AutoCallCompanionFrame.Enabled = CreateFrame("CheckButton", "$parentEnabled"  , self.AutoCallCompanionFrame , "GupPet_InterfaceSmallCheckButtonTemplate");
		self.AutoCallCompanionFrame.Enabled:SetPoint("TOPLEFT", 10, -10 );
		self.AutoCallCompanionFrame.Enabled:SetChecked( GupPet_SavedOptions["AutoCritter"]["Enabled"]  ); 
		self.AutoCallCompanionFrame.Enabled:SetScript("OnClick", function (self, button, down) GupPet_SavedOptions["AutoCritter"]["Enabled"]=self:GetChecked();  GupPet_Companion_AutoSetEnable();   end);
		self.AutoCallCompanionFrame.Enabled.text:SetText( GUPPET_L["AUTOCALLCOMPANIONFRAME_ENABLE"] );
	
		self.AutoCallCompanionFrame.EnabledCity = CreateFrame("CheckButton", "$parentEnabledCity"  , self.AutoCallCompanionFrame , "GupPet_InterfaceCheckButtonTemplate");
		self.AutoCallCompanionFrame.EnabledCity:SetPoint("TOPLEFT", 20, -32 );
		self.AutoCallCompanionFrame.EnabledCity:SetChecked( GupPet_SavedOptions["AutoCritter"]["City"] ); 
		self.AutoCallCompanionFrame.EnabledCity:SetScript("OnClick", function (self, button, down)  GupPet_SavedOptions["AutoCritter"]["City"]=self:GetChecked();  end);
		self.AutoCallCompanionFrame.EnabledCity.text:SetText( GUPPET_L["AUTOCALLCOMPANIONFRAME_CITY"] );
	
		self.AutoCallCompanionFrame.EnabledOutside = CreateFrame("CheckButton", "$parentEnabledOutside"  , self.AutoCallCompanionFrame , "GupPet_InterfaceCheckButtonTemplate");
		self.AutoCallCompanionFrame.EnabledOutside:SetPoint("TOPLEFT", 20, -47 );
		self.AutoCallCompanionFrame.EnabledOutside:SetChecked( GupPet_SavedOptions["AutoCritter"]["Outside"] ); 
		self.AutoCallCompanionFrame.EnabledOutside:SetScript("OnClick", function (self, button, down)  GupPet_SavedOptions["AutoCritter"]["Outside"]=self:GetChecked();  end);
		self.AutoCallCompanionFrame.EnabledOutside.text:SetText( GUPPET_L["AUTOCALLCOMPANIONFRAME_OUTSIDE"] );
	
		self.AutoCallCompanionFrame.EnabledArena = CreateFrame("CheckButton", "$parentEnabledArena"  , self.AutoCallCompanionFrame , "GupPet_InterfaceCheckButtonTemplate");
		self.AutoCallCompanionFrame.EnabledArena:SetPoint("TOPLEFT", 20, -62 );
		self.AutoCallCompanionFrame.EnabledArena:SetChecked( GupPet_SavedOptions["AutoCritter"]["Arena"] ); 
		self.AutoCallCompanionFrame.EnabledArena:SetScript("OnClick", function (self, button, down)  GupPet_SavedOptions["AutoCritter"]["Arena"]=self:GetChecked();  end);
		self.AutoCallCompanionFrame.EnabledArena.text:SetText( GUPPET_L["AUTOCALLCOMPANIONFRAME_ARENA"] );
	
		self.AutoCallCompanionFrame.EnabledParty = CreateFrame("CheckButton", "$parentEnabledParty"  , self.AutoCallCompanionFrame , "GupPet_InterfaceCheckButtonTemplate");
		self.AutoCallCompanionFrame.EnabledParty:SetPoint("TOPLEFT", 20, -77 );
		self.AutoCallCompanionFrame.EnabledParty:SetChecked( GupPet_SavedOptions["AutoCritter"]["Party"] ); 
		self.AutoCallCompanionFrame.EnabledParty:SetScript("OnClick", function (self, button, down)  GupPet_SavedOptions["AutoCritter"]["Party"]=self:GetChecked();  end);
		self.AutoCallCompanionFrame.EnabledParty.text:SetText( GUPPET_L["AUTOCALLCOMPANIONFRAME_PARTY"] );	

		self.AutoCallCompanionFrame.EnabledRaid = CreateFrame("CheckButton", "$parentEnabledRaid"  , self.AutoCallCompanionFrame , "GupPet_InterfaceCheckButtonTemplate");
		self.AutoCallCompanionFrame.EnabledRaid:SetPoint("TOPLEFT", 20, -92 );
		self.AutoCallCompanionFrame.EnabledRaid:SetChecked( GupPet_SavedOptions["AutoCritter"]["Raid"] ); 
		self.AutoCallCompanionFrame.EnabledRaid:SetScript("OnClick", function (self, button, down)  GupPet_SavedOptions["AutoCritter"]["Raid"]=self:GetChecked();  end);
		self.AutoCallCompanionFrame.EnabledRaid.text:SetText( GUPPET_L["AUTOCALLCOMPANIONFRAME_RAID"] );			
	
		self.AutoCallCompanionFrame.EnabledBattleGround = CreateFrame("CheckButton", "$parentEnabledBattleGround"  , self.AutoCallCompanionFrame , "GupPet_InterfaceCheckButtonTemplate");
		self.AutoCallCompanionFrame.EnabledBattleGround:SetPoint("TOPLEFT", 20, -107 );
		self.AutoCallCompanionFrame.EnabledBattleGround:SetChecked( GupPet_SavedOptions["AutoCritter"]["BattleGround"] ); 
		self.AutoCallCompanionFrame.EnabledBattleGround:SetScript("OnClick", function (self, button, down)  GupPet_SavedOptions["AutoCritter"]["BattleGround"]=self:GetChecked();  end);
		self.AutoCallCompanionFrame.EnabledBattleGround.text:SetText( GUPPET_L["AUTOCALLCOMPANIONFRAME_BATTLEGROUND"] );	
		
		self.AutoCallCompanionFrame.CallDelay = CreateFrame('Slider', "$parentCallDelay", self.AutoCallCompanionFrame , 'GupPet_InterfaceBigSliderTemplate');
		self.AutoCallCompanionFrame.CallDelay:SetPoint('TOP', 0, -140); 
		self.AutoCallCompanionFrame.CallDelay:SetOrientation('HORIZONTAL');
		self.AutoCallCompanionFrame.CallDelay:SetWidth(140) ;
		self.AutoCallCompanionFrame.CallDelay:SetHeight(17);
		self.AutoCallCompanionFrame.CallDelay:SetMinMaxValues( 2 , 10 );
		self.AutoCallCompanionFrame.CallDelay:SetValueStep(0.1) ;
		self.AutoCallCompanionFrame.CallDelay:SetValue( GupPet_SavedOptions["AutoCritter"]["Delay"] );
		self.AutoCallCompanionFrame.CallDelay:SetScript("OnValueChanged", function (self)   GupPet_SavedOptions["AutoCritter"]["Delay"] = self:GetValue() ;   end);
		self.AutoCallCompanionFrame.CallDelay.text:SetText(GUPPET_L["AUTOCALLCOMPANIONFRAME_DELAY"]) ;
		self.AutoCallCompanionFrame.CallDelay.low:SetText(GUPPET_L["2"]) ;
		self.AutoCallCompanionFrame.CallDelay.high:SetText(GUPPET_L["10"]) ;
		self.AutoCallCompanionFrame.CallDelay.tooltipText = GUPPET_L["AUTOCALLCOMPANIONFRAME_DELAYTOOLTIP"];
	
		self.AutoCallCompanionFrame.DismissMounted = CreateFrame("CheckButton", "$parentDismissMounted"  , self.AutoCallCompanionFrame , "GupPet_InterfaceCheckButtonTemplate");
		self.AutoCallCompanionFrame.DismissMounted:SetPoint("TOPLEFT", 20, -170 );
		self.AutoCallCompanionFrame.DismissMounted:SetChecked( GupPet_SavedOptions["AutoCritter"]["DismissMounted"] ); 
		self.AutoCallCompanionFrame.DismissMounted:SetScript("OnClick", function (self, button, down)  GupPet_SavedOptions["AutoCritter"]["DismissMounted"]=self:GetChecked();  end);
		self.AutoCallCompanionFrame.DismissMounted.text:SetText( GUPPET_L["AUTOCALLCOMPANIONFRAME_AUTODISMISSMOUNTED"] );	

		self.AutoCallCompanionFrame.EnabledResummon = CreateFrame("CheckButton", "$parentEnabledResummon"  , self.AutoCallCompanionFrame , "GupPet_InterfaceCheckButtonTemplate");
		self.AutoCallCompanionFrame.EnabledResummon:SetPoint("TOPLEFT", 20, -205 );
		self.AutoCallCompanionFrame.EnabledResummon:SetChecked( GupPet_SavedOptions["AutoCritter"]["Resummon"]["Enabled"] ); 
		self.AutoCallCompanionFrame.EnabledResummon:SetScript("OnClick", function (self, button, down)  GupPet_SavedOptions["AutoCritter"]["Resummon"]["Enabled"]=self:GetChecked(); GupPet_Companion_AutoResumonSetEnable();  end);
		self.AutoCallCompanionFrame.EnabledResummon.text:SetText( GUPPET_L["AUTOCALLCOMPANIONFRAME_ENABLERESUMMON"] );		
		
		self.AutoCallCompanionFrame.ResummonDelay = CreateFrame('Slider', "$parentCallDelay", self.AutoCallCompanionFrame , 'GupPet_InterfaceBigSliderTemplate');
		self.AutoCallCompanionFrame.ResummonDelay:SetPoint('TOP', 0, -220); 
		self.AutoCallCompanionFrame.ResummonDelay:SetOrientation('HORIZONTAL');
		self.AutoCallCompanionFrame.ResummonDelay:SetWidth(140) ;
		self.AutoCallCompanionFrame.ResummonDelay:SetHeight(17);
		self.AutoCallCompanionFrame.ResummonDelay:SetMinMaxValues( 30 , 600 );
		self.AutoCallCompanionFrame.ResummonDelay:SetValueStep(30) ;
		self.AutoCallCompanionFrame.ResummonDelay:SetValue( GupPet_SavedOptions["AutoCritter"]["Resummon"]["Delay"] );
		self.AutoCallCompanionFrame.ResummonDelay:SetScript("OnValueChanged", function (self)   GupPet_SavedOptions["AutoCritter"]["Resummon"]["Delay"] = self:GetValue() ;   end);
		self.AutoCallCompanionFrame.ResummonDelay.text:SetText(GUPPET_L["AUTOCALLCOMPANIONFRAME_RESUMMONDELAY"]) ;
		self.AutoCallCompanionFrame.ResummonDelay.low:SetText(GUPPET_L["30"]) ;
		self.AutoCallCompanionFrame.ResummonDelay.high:SetText(GUPPET_L["600"]) ;
		self.AutoCallCompanionFrame.ResummonDelay.tooltipText = GUPPET_L["AUTOCALLCOMPANIONFRAME_RESUMMONDELAYTOOLTIP"];
		
		self.AutoCallCompanionFrame.ResummonCityOnly = CreateFrame("CheckButton", "$parentResummonCityOnly"  , self.AutoCallCompanionFrame , "GupPet_InterfaceCheckButtonTemplate");
		self.AutoCallCompanionFrame.ResummonCityOnly:SetPoint("TOPLEFT", 20, -248 );
		self.AutoCallCompanionFrame.ResummonCityOnly:SetChecked( GupPet_SavedOptions["AutoCritter"]["Resummon"]["CityOnly"] ); 
		self.AutoCallCompanionFrame.ResummonCityOnly:SetScript("OnClick", function (self, button, down)  GupPet_SavedOptions["AutoCritter"]["Resummon"]["CityOnly"]=self:GetChecked(); end);
		self.AutoCallCompanionFrame.ResummonCityOnly.text:SetText( GUPPET_L["AUTOCALLCOMPANIONFRAME_RESUMMONCITYONLY"] );		
		
		self.AutoCallCompanionFrame.PetOfTheDay = CreateFrame("CheckButton", "$parentPetOfTheDay"  , self.AutoCallCompanionFrame , "GupPet_InterfaceCheckButtonTemplate");
		self.AutoCallCompanionFrame.PetOfTheDay:SetPoint("TOPLEFT", 20, -265 );
		self.AutoCallCompanionFrame.PetOfTheDay:SetChecked( GupPet_SavedOptions["AutoCritter"]["PetOfTheDay"]["Enabled"] ); 
		self.AutoCallCompanionFrame.PetOfTheDay:SetScript("OnClick", function (self, button, down)  GupPet_SavedOptions["AutoCritter"]["PetOfTheDay"]["Enabled"]=self:GetChecked(); end);
		self.AutoCallCompanionFrame.PetOfTheDay.text:SetText( GUPPET_L["AUTOCALLCOMPANIONFRAME_PETOFTHEDAY"] );			
		self.AutoCallCompanionFrame.PetOfTheDay.tooltipText = GUPPET_L["AUTOCALLCOMPANIONFRAME_PETOFTHEDAYTOOLTIP"] ;
		
		----------------------------------------------------------------------------
		----------------------------------------------------------------------------
		-- Extra
		self.ExtraFrame = CreateFrame("FRAME", "$parentExtraFrame", self , "GupPet_InterfaceFrameTitlePartTemplate");
 		self.ExtraFrame:SetWidth(180);
		self.ExtraFrame:SetHeight(70);	
		self.ExtraFrame:SetPoint("TOPRIGHT", -10 , -30);
		self.ExtraFrame.Title:SetText( "|cFFFC830E".. GUPPET_L["EXTRAFRAME"] );
		
		self.ExtraFrame.AutoDismount = CreateFrame("CheckButton", "$parentAutoDismount"  , self.ExtraFrame , "GupPet_InterfaceSmallCheckButtonTemplate");
		self.ExtraFrame.AutoDismount:SetPoint("TOPLEFT", 10, -10 );
		self.ExtraFrame.AutoDismount:SetChecked( GupPet_SavedOptions["AutoDismount"]  ); 
		self.ExtraFrame.AutoDismount:SetScript("OnClick", function (self, button, down) GupPet_SavedOptions["AutoDismount"]=self:GetChecked();  GupPet_Mount_UpdateAutoDismount();   end);
		self.ExtraFrame.AutoDismount.text:SetText( GUPPET_L["EXTRAFRAME_AUTODISMOUNT"] );
		self.ExtraFrame.AutoDismount.tooltipText = GUPPET_L["EXTRAFRAME_AUTODISMOUNTTOOLTIP"] ;
		
		self.ExtraFrame.Style = CreateFrame("CheckButton", "$parentStyle"  , self.ExtraFrame , "GupPet_InterfaceSmallCheckButtonTemplate");
		self.ExtraFrame.Style:SetPoint("TOPLEFT", 10, -30 );
		self.ExtraFrame.Style:SetChecked( not(GupPet_SavedOptions["Style"] == "CheckBox" )  ); 
		self.ExtraFrame.Style:SetScript("OnClick", function (self, button, down) StaticPopup_Show ("GupPet_Interface_ChangeStyle");   end);
		self.ExtraFrame.Style.text:SetText( GUPPET_L["EXTRAFRAME_CHANGESTYLE"] );
		self.ExtraFrame.Style.tooltipText = GUPPET_L["EXTRAFRAME_CHANGESTYLETOOLTIP"] ;
		
	
		----------------------------------------------------------------------------
		----------------------------------------------------------------------------
		-- PREVIEW FRAME
		self.PreviewFrame = CreateFrame("FRAME", "$parentPreviewFrame", self , "GupPet_InterfaceFrameTitlePartTemplate");
 		self.PreviewFrame:SetWidth(200);
		self.PreviewFrame:SetHeight(95);	
		self.PreviewFrame:SetPoint("TOPLEFT", 10 , -220);
		self.PreviewFrame.Title:SetText( "|cFFFC830E".. GUPPET_L["PREVIEWFRAME"] );
		
		self.PreviewFrame.Speed = CreateFrame('Slider', "$parentSpeed", self.PreviewFrame , 'GupPet_InterfaceBigSliderTemplate');
		self.PreviewFrame.Speed:SetPoint('TOP', 0, -20); 
		self.PreviewFrame.Speed:SetOrientation('HORIZONTAL');
		self.PreviewFrame.Speed:SetWidth(160) ;
		self.PreviewFrame.Speed:SetHeight(17);
		self.PreviewFrame.Speed:SetMinMaxValues( -1 , 1 );
		self.PreviewFrame.Speed:SetValueStep(0.25) ;
		self.PreviewFrame.Speed:SetValue( GupPet_SavedOptions["PreviewFrame"]["Speed"] );
		self.PreviewFrame.Speed:SetScript("OnValueChanged", function (self)   GupPet_SavedOptions["PreviewFrame"]["Speed"] = self:GetValue() ;   end);
		self.PreviewFrame.Speed.text:SetText(GUPPET_L["PREVIEWFRAME_SPEED"]) ;
		self.PreviewFrame.Speed.low:SetText(GUPPET_L["PREVIEWFRAME_SPEEDLOW"]) ;
		self.PreviewFrame.Speed.high:SetText(GUPPET_L["PREVIEWFRAME_SPEEDHIGH"]) ;

		self.PreviewFrame.StartPos = CreateFrame('Slider', "$parentStartPos", self.PreviewFrame , 'GupPet_InterfaceBigSliderTemplate');
		self.PreviewFrame.StartPos:SetPoint('TOP', 0, -63); 
		self.PreviewFrame.StartPos:SetOrientation('HORIZONTAL');
		self.PreviewFrame.StartPos:SetWidth(160) ;
		self.PreviewFrame.StartPos:SetHeight(17);
		self.PreviewFrame.StartPos:SetMinMaxValues( -3.14 , 3.14 );
		self.PreviewFrame.StartPos:SetValueStep(0.1) ;
		self.PreviewFrame.StartPos:SetValue( GupPet_SavedOptions["PreviewFrame"]["StartPos"] );
		self.PreviewFrame.StartPos:SetScript("OnValueChanged", function (self)   GupPet_SavedOptions["PreviewFrame"]["StartPos"] = self:GetValue() ;   end);
		self.PreviewFrame.StartPos.text:SetText(GUPPET_L["PREVIEWFRAME_STARTPOS"]) ;
		self.PreviewFrame.StartPos.low:SetText(GUPPET_L["PREVIEWFRAME_STARTPOSLOW"]) ;
		self.PreviewFrame.StartPos.high:SetText(GUPPET_L["PREVIEWFRAME_STARTPOSHIGH"]) ;

		----------------------------------------------------------------------------
		----------------------------------------------------------------------------
		-- MINIMAPBUTTON
		self.MinimapFrame = CreateFrame("FRAME", "$parentMinimapFrame", self , "GupPet_InterfaceFrameTitlePartTemplate");
 		self.MinimapFrame:SetWidth(210);
		self.MinimapFrame:SetHeight(43);	
		self.MinimapFrame:SetPoint("BOTTOMLEFT", 10 , 10);
		self.MinimapFrame.Title:SetText( "|cFFFC830E".. GUPPET_L["MINIMAPFRAME"] );
	
		self.MinimapFrame.Show = CreateFrame("CheckButton", "$parentShow"  , self.MinimapFrame , "GupPet_InterfaceSmallCheckButtonTemplate");
		self.MinimapFrame.Show:SetPoint("TOPLEFT", 10, -10 );
		self.MinimapFrame.Show:SetChecked( GupPet_SavedOptions["MinimapButton"]["Show"] ); 
		self.MinimapFrame.Show:SetScript("OnClick", function (self, button, down) GupPet_SavedOptions["MinimapButton"]["Show"]=self:GetChecked();  GupPet_InterfaceMinimapButton_Update();   end);
		self.MinimapFrame.Show.text:SetText( GUPPET_L["MINIMAPFRAME_SHOW"] );

		
		----------------------------------------------------------------------------
		----------------------------------------------------------------------------
	
	end

end


----------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------

----------------------------------------------------------------------------------------------------------------
--[[ 	GupPet_InterfaceHelpAboutFrame_OnShow																	]]--
----------------------------------------------------------------------------------------------------------------
function GupPet_InterfaceClassFrame_OnShow(self)

	-- Do Stuf at first Show 
	if not self.Shown then
		self.Shown = 1 ;
	end

	-- Create the menu
	if GupPet_TempUserData.UnitClass == "DRUID" or GupPet_TempUserData.UnitClass == "SHAMAN" or GupPet_TempUserData.UnitClass == "MAGE" or GupPet_TempUserData.UnitClass == "DEATHKNIGHT" or GupPet_TempUserData.UnitClass == "WORGEN" then
	
	
	
	end
	
	
	
	if GupPet_TempUserData.UnitClass == "DRUID" then
		-- Enable / Disable --> Travel / SlowFly / FastFly / Aquatic // AND what mode 

		
	elseif GupPet_TempUserData.UnitClass == "SHAMAN" then
		-- Enable / Disable --> Ghost enable on Moving  // AND what mode 
	
	elseif GupPet_TempUserData.UnitClass == "MAGE" then
		-- Enable / Disable --> Slowfall on falling  
	
	elseif GupPet_TempUserData.UnitClass == "DEATHKNIGHT" then
		-- Enable / Disable --> Patch of frost
	
	elseif GupPet_TempUserData.UnitClass == "WORGEN" then
	
	end
	
	
	
	
	--[[
----------------------------------------------------------------------------
		----------------------------------------------------------------------------
		-- CLASS
		if GupPetet_TempClassData.Type == "DRUID" or GupPetet_TempClassData.Type == "SHAMAN" or GupPetet_TempClassData.Type == "MAGE" or GupPetet_TempClassData.Type == "DEATHKNIGHT" then

			GUPPET_INTERFACE_OPTIONFRAME.ClassFrame = CreateFrame("FRAME", "GupPetet_ClassFrame", GupPetet_InterfaceOptionsFrameOptions , "GupPetet_FieldTemplate");
			GUPPET_INTERFACE_OPTIONFRAME.ClassFrame:SetWidth(210);
			GUPPET_INTERFACE_OPTIONFRAME.ClassFrame:SetHeight(70);	
			GUPPET_INTERFACE_OPTIONFRAME.ClassFrame:SetPoint("BOTTOMRIGHT", -10 , 10);
			_G["GupPetet_ClassFrame" .. "SubTitle"]:SetText("|cFFFC830E".. GUPPET_L["CLASS"][1]) ;	
		
		end
		
		if GupPetet_TempClassData.Type == "DRUID" then
			-- Enable / Disable --> Travel / SlowFly / FastFly / Aquatic
			GUPPET_INTERFACE_OPTIONFRAME.ClassFrame:SetHeight(80);
	 
	 	 	GUPPET_INTERFACE_OPTIONFRAME.DRUID_Fly = CreateFrame("CheckButton", "GupPetet_DRUID_Fly"  , GUPPET_INTERFACE_OPTIONFRAME.ClassFrame , "GupPet_InterfaceSmallCheckButtonTemplate");
			GUPPET_INTERFACE_OPTIONFRAME.DRUID_Fly:SetPoint("TOPLEFT", 10, -10 );
			GUPPET_INTERFACE_OPTIONFRAME.DRUID_Fly:SetScript("OnClick", function (self, button, down)   GupPet_SavedOptions["Class"]["FlyForm"] = self:GetChecked()  end);
			GUPPET_INTERFACE_OPTIONFRAME.DRUID_Fly:SetChecked(  GupPet_SavedOptions["Class"]["FlyForm"]  ); 
			_G["GupPetet_DRUID_Fly" .. "Text"]:SetText( GUPPET_L["DRUID_Fly"][1]  ) ;
			
			GUPPET_INTERFACE_OPTIONFRAME.DRUID_Aquatic = CreateFrame("CheckButton", "GupPetet_DRUID_Aquatic"  , GUPPET_INTERFACE_OPTIONFRAME.ClassFrame , "GupPet_InterfaceSmallCheckButtonTemplate");
			GUPPET_INTERFACE_OPTIONFRAME.DRUID_Aquatic:SetPoint("TOPLEFT", 10, -25 );
			GUPPET_INTERFACE_OPTIONFRAME.DRUID_Aquatic:SetScript("OnClick", function (self, button, down)   GupPet_SavedOptions["Class"]["AquaticForm"] = self:GetChecked()  end);
			GUPPET_INTERFACE_OPTIONFRAME.DRUID_Aquatic:SetChecked(  GupPet_SavedOptions["Class"]["AquaticForm"]  ); 
			_G["GupPetet_DRUID_Aquatic" .. "Text"]:SetText( GUPPET_L["DRUID_Aquatic"][1]  ) ;	
			
			GUPPET_INTERFACE_OPTIONFRAME.DRUID_Travel = CreateFrame("CheckButton", "GupPetet_DRUID_Travel"  , GUPPET_INTERFACE_OPTIONFRAME.ClassFrame , "GupPet_InterfaceSmallCheckButtonTemplate");
			GUPPET_INTERFACE_OPTIONFRAME.DRUID_Travel:SetPoint("TOPLEFT", 10, -40 );
			GUPPET_INTERFACE_OPTIONFRAME.DRUID_Travel:SetScript("OnClick", function (self, button, down)   GupPet_SavedOptions["Class"]["TravelOnFormWalking"] = self:GetChecked()  end);
			GUPPET_INTERFACE_OPTIONFRAME.DRUID_Travel:SetChecked(  GupPet_SavedOptions["Class"]["TravelOnFormWalking"]  ); 
			_G["GupPetet_DRUID_Travel" .. "Text"]:SetText( GUPPET_L["DRUID_Travel"][1]  ) ;	
			
			GUPPET_INTERFACE_OPTIONFRAME.DRUID_Cat = CreateFrame("CheckButton", "GupPetet_DRUID_Cat"  , GUPPET_INTERFACE_OPTIONFRAME.ClassFrame , "GupPet_InterfaceSmallCheckButtonTemplate");
			GUPPET_INTERFACE_OPTIONFRAME.DRUID_Cat:SetPoint("TOPLEFT", 10, -55 );
			GUPPET_INTERFACE_OPTIONFRAME.DRUID_Cat:SetScript("OnClick", function (self, button, down)   GupPet_SavedOptions["Class"]["CatOnIndoors"] = self:GetChecked()  end);
			GUPPET_INTERFACE_OPTIONFRAME.DRUID_Cat:SetChecked(  GupPet_SavedOptions["Class"]["CatOnIndoors"]  ); 
			_G["GupPetet_DRUID_Cat" .. "Text"]:SetText( GUPPET_L["DRUID_Cat"][1]  ) ;	
			
		elseif GupPetet_TempClassData.Type == "SHAMAN" then
			-- Enable / Disable --> Ghost enable on Moving 
			GUPPET_INTERFACE_OPTIONFRAME.ClassFrame:SetHeight(60);
			
	 		GUPPET_INTERFACE_OPTIONFRAME.SHAMAN_Ghost = CreateFrame("CheckButton", "GupPetet_SHAMAN_Ghost"  , GUPPET_INTERFACE_OPTIONFRAME.ClassFrame , "GupPet_InterfaceSmallCheckButtonTemplate");
			GUPPET_INTERFACE_OPTIONFRAME.SHAMAN_Ghost:SetPoint("TOPLEFT", 10, -10 );
			GUPPET_INTERFACE_OPTIONFRAME.SHAMAN_Ghost:SetScript("OnClick", function (self, button, down)   GupPet_SavedOptions["Class"]["GhostWolfOnWalking"] = self:GetChecked()  end);
			GUPPET_INTERFACE_OPTIONFRAME.SHAMAN_Ghost:SetChecked(  GupPet_SavedOptions["Class"]["GhostWolfOnWalking"]  ); 
			_G["GupPetet_SHAMAN_Ghost" .. "Text"]:SetText( GUPPET_L["SHAMAN_Ghost"][1]  ) ;
			
			-- WaterWalking
			GUPPET_INTERFACE_OPTIONFRAME.SHAMAN_WaterWalking = CreateFrame("CheckButton", "GupPetet_SHAMAN_WaterWalking"  , GUPPET_INTERFACE_OPTIONFRAME.ClassFrame , "GupPet_InterfaceSmallCheckButtonTemplate");
			GUPPET_INTERFACE_OPTIONFRAME.SHAMAN_WaterWalking:SetPoint("TOPLEFT", 10, -25 );
			GUPPET_INTERFACE_OPTIONFRAME.SHAMAN_WaterWalking:SetScript("OnClick", function (self, button, down)   GupPet_SavedOptions["Class"]["UseWaterWalking"] = self:GetChecked()  end);
			GUPPET_INTERFACE_OPTIONFRAME.SHAMAN_WaterWalking:SetChecked(  GupPet_SavedOptions["Class"]["UseWaterWalking"]  ); 
			_G["GupPetet_SHAMAN_WaterWalking" .. "Text"]:SetText( GUPPET_L["SHAMAN_WaterWalking"][1]  ) ;
			
		
		elseif GupPetet_TempClassData.Type == "MAGE" then
			-- Enable / Disable --> Slowfall on falling  
			GUPPET_INTERFACE_OPTIONFRAME.ClassFrame:SetHeight(40);
			
	 		GUPPET_INTERFACE_OPTIONFRAME.MAGE_SlowFall = CreateFrame("CheckButton", "GupPetet_MAGE_SlowFall"  , GUPPET_INTERFACE_OPTIONFRAME.ClassFrame , "GupPet_InterfaceSmallCheckButtonTemplate");
			GUPPET_INTERFACE_OPTIONFRAME.MAGE_SlowFall:SetPoint("TOPLEFT", 10, -10 );
			GUPPET_INTERFACE_OPTIONFRAME.MAGE_SlowFall:SetScript("OnClick", function (self, button, down)   GupPet_SavedOptions["Class"]["SlowFallOnFalling"] = self:GetChecked()  end);
			GUPPET_INTERFACE_OPTIONFRAME.MAGE_SlowFall:SetChecked(  GupPet_SavedOptions["Class"]["SlowFallOnFalling"]  ); 
			_G["GupPetet_MAGE_SlowFall" .. "Text"]:SetText( GUPPET_L["MAGE_SlowFall"][1]  ) ;
			
			
		elseif GupPetet_TempClassData.Type == "DEATHKNIGHT" then
			 
			GUPPET_INTERFACE_OPTIONFRAME.ClassFrame:SetHeight(40);
			
	 		GUPPET_INTERFACE_OPTIONFRAME.DEATHKNIGHT_PathOfFrost = CreateFrame("CheckButton", "GupPetet_DEATHKNIGHT_PathOfFrost"  , GUPPET_INTERFACE_OPTIONFRAME.ClassFrame , "GupPet_InterfaceSmallCheckButtonTemplate");
			GUPPET_INTERFACE_OPTIONFRAME.DEATHKNIGHT_PathOfFrost:SetPoint("TOPLEFT", 10, -10 );
			GUPPET_INTERFACE_OPTIONFRAME.DEATHKNIGHT_PathOfFrost:SetScript("OnClick", function (self, button, down)   GupPet_SavedOptions["Class"]["UsePathOfFrost"] = self:GetChecked()  end);
			GUPPET_INTERFACE_OPTIONFRAME.DEATHKNIGHT_PathOfFrost:SetChecked(  GupPet_SavedOptions["Class"]["UsePathOfFrost"]  ); 
			_G["GupPetet_DEATHKNIGHT_PathOfFrost" .. "Text"]:SetText( GUPPET_L["DEATHKNIGHT_PathOfFrost"][1]  ) ;
			
			
		end
	]]
end

----------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------

----------------------------------------------------------------------------------------------------------------
--[[ 	GupPet_InterfaceHelpAboutFrame_OnShow																	]]--
----------------------------------------------------------------------------------------------------------------
function GupPet_InterfaceHelpAboutFrame_OnShow(self)

	-- Do Stuf at first Show 
	if not self.Shown then
		self.Shown = 1 ;
	end

--[[
----------------------------------------------------------------------------
		----------------------------------------------------------------------------
		-- HELPFRAME
		GUPPET_INTERFACE_OPTIONFRAME.SlashFrame = CreateFrame("FRAME", "GupPetet_SlashFrame", GupPetet_InterfaceOptionsFrameHelp , "GupPetet_FieldTemplate");
 		GUPPET_INTERFACE_OPTIONFRAME.SlashFrame:SetWidth(660);
		GUPPET_INTERFACE_OPTIONFRAME.SlashFrame:SetHeight(160);	
		GUPPET_INTERFACE_OPTIONFRAME.SlashFrame:SetPoint("BOTTOMLEFT", 10 , 10);
		_G["GupPetet_SlashFrame" .. "SubTitle"]:SetText("|cFFFC830E".. GUPPET_L["SLASHCOMMANDS"][1]) ;	
				
		GUPPET_INTERFACE_OPTIONFRAME.SlashCommands = CreateFrame("SimpleHTML", "GupPetet_Slash" , GUPPET_INTERFACE_OPTIONFRAME.SlashFrame );
		GUPPET_INTERFACE_OPTIONFRAME.SlashCommands:SetWidth(640); 
		GUPPET_INTERFACE_OPTIONFRAME.SlashCommands:SetHeight(50); 
		GUPPET_INTERFACE_OPTIONFRAME.SlashCommands:SetPoint("TOPLEFT", 10 , -10);
		GUPPET_INTERFACE_OPTIONFRAME.SlashCommands:SetText("<html><body><p>"..
															GUPPET_S["SLASH"].."<br /><br />"..
															
															"'"..GUPPET_S["MULTIMOUNT"][1] 	.."'"..	GUPPET_S["USE"]	.."'".. GUPPET_S["MULTIMOUNT"][2] .."' ".. GUPPET_S["MULTIMOUNT"][3] .."<br />"..															
															"'"..GUPPET_S["AQUATICMOUNT"][1] 		.."'"..	GUPPET_S["USE"]	.."'".. GUPPET_S["AQUATICMOUNT"][2] 	.."' ".. GUPPET_S["AQUATICMOUNT"][3] .."<br />"..
															"'"..GUPPET_S["AUTOMOUNT"][1] 			.."'"..	GUPPET_S["USE"]	.."'".. GUPPET_S["AUTOMOUNT"][2] 			.."' ".. GUPPET_S["AUTOMOUNT"][3] .."<br />"..
															"'"..GUPPET_S["GROUNDMOUNT"][1] 	.."'"..	GUPPET_S["USE"]	.."'".. GUPPET_S["GROUNDMOUNT"][2] 	.."' ".. GUPPET_S["GROUNDMOUNT"][3] .."<br />"..
															"'"..GUPPET_S["FLYMOUNT"][1] 		.."'"..	GUPPET_S["USE"]	.."'".. GUPPET_S["FLYMOUNT"][2] 	.."' ".. GUPPET_S["FLYMOUNT"][3] .."<br />"..
															"'"..GUPPET_S["CALLCOMPANION"][1] 	.."'"..	GUPPET_S["USE"]	.."'".. GUPPET_S["CALLCOMPANION"][2] 		.."' ".. GUPPET_S["CALLCOMPANION"][3] .."<br />"..
															"'"..GUPPET_S["OPTIONMENU"][1] 		.."'"..	GUPPET_S["USE"]	.."'".. GUPPET_S["OPTIONMENU"][2] 		.."' ".. GUPPET_S["OPTIONMENU"][3] .."<br />"..
														 
															" </p></body></html>"    ) ;
		GUPPET_INTERFACE_OPTIONFRAME.SlashCommands:SetFont('Fonts\\FRIZQT__.TTF', 10);

]]
end

----------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------

----------------------------------------------------------------------------------------------------------------
--[[ 	GupPet_InterfaceCompanionFrame_OnShow																	]]--
----------------------------------------------------------------------------------------------------------------
function GupPet_InterfaceCompanionFrame_OnShow(self)

	-- Do Stuf at first Show 
	if not self.Shown then
		self.Shown = 1 ;
	
		GupPet_InterfaceCompanion_LocationFrame_Update();
		
		-- Set to the first Tab
		GupPet_InterfaceCompanion_Tabs_Update();
		GupPet_Interface_ShowTab( _G["GupPet_InterfaceFrameCompanionTab1"] ) ;
		
		-- Set to the first index
		GupPet_InterfaceLocatinList_SetSelected( 1 ) ;
		
	end

end

---------
---------
---------

----------------------------------------------------------------------------------------------------------------
--[[ 	GupPet_InterfaceCompanion_MainFrame_Update															]]--
----------------------------------------------------------------------------------------------------------------
function GupPet_InterfaceCompanion_MainFrame_Update()
	
 	-- Select BuildFrame
	local mainFrame =  _G["GupPet_InterfaceFrameCompanionMain"];
			
	-- Selected ID and bookType
	local selected = GupPet_InterfaceLocationList_GetSelected();
	local selectedBookType = GupPet_InterfaceCompanion_Tabs_GetSelectedBookType();
	
	if selectedBookType == nil or selected == nil then return end	--Dont update if its not needid
	
	
	-- For some Booktypes there are options
	local listHeight = 370 ;
	local listXOffset = 0 ;
	local listYOffset = 0 ;
	
	if selectedBookType == "GroundMount" then
		
		-- Add this
		if not mainFrame.UseFlyAsGround then
			mainFrame.UseFlyAsGround = CreateFrame("CheckButton", "$parentUseFlyAsGround" , mainFrame , "GupPet_InterfaceCheckButtonTemplate"); 
			mainFrame.UseFlyAsGround:SetPoint("TOPLEFT", 10 , -10  );
			mainFrame.UseFlyAsGround.text:SetText(GUPPET_L["USEFLYASGROUND"]);
			mainFrame.UseFlyAsGround.tooltipText = GUPPET_L["USEFLYASGROUNDTOOLTIP"];
			mainFrame.UseFlyAsGround.tooltipRequirement = GUPPET_L["USEFLYASGROUNDTOOLTIPR"];
		end
		
		mainFrame.UseFlyAsGround:SetChecked( GupPet_DataHandler_Location_GetUserFlyAsGround( selected["Index"] ) );
		mainFrame.UseFlyAsGround:SetScript("OnClick", function (self) GupPet_DataHandler_Location_SetUseFlyAsGround( selected["Index"] , self:GetChecked() ) ;  end );
		mainFrame.UseFlyAsGround:Show();
	else
		if mainFrame.UseFlyAsGround then
			mainFrame.UseFlyAsGround:Hide();
		end 
	end
	
	
	-- Generate List
	-- GupPet_InterfaceDataFieldTemplate
	if not mainFrame.CompanionList then
		mainFrame.CompanionList = CreateFrame("FRAME", "$parentCompanionList", mainFrame , "GupPet_InterfaceDataFieldTemplate");
		mainFrame.CompanionList:SetWidth(450);
		
		_G["GupPet_InterfaceFrameCompanionMain".."CompanionList".."Container"]:SetWidth(418);
		
		_G["GupPet_InterfaceFrameCompanionMain".."CompanionList".."Enable"]:SetScript("OnClick", function () GupPet_InterfaceFrameCompanion_MainCompanionList_OnChange( 0 , 1 ); GupPet_InterfaceCompanion_MainFrame_Update(); end) ;
		_G["GupPet_InterfaceFrameCompanionMain".."CompanionList".."Disable"]:SetScript("OnClick", function () GupPet_InterfaceFrameCompanion_MainCompanionList_OnChange( 0 , 0 ); GupPet_InterfaceCompanion_MainFrame_Update(); end) ;
	end
	
	mainFrame.CompanionList:SetHeight( listHeight );
	mainFrame.CompanionList:SetPoint("TOPLEFT", 10+listXOffset , -30+listYOffset  );
	
	_G["GupPet_InterfaceFrameCompanionMain".."CompanionList".."Container"]:SetHeight(listHeight-10);
	
	
	--------- GupPet_SavedData["Companion"]["GroundMount"]
	---------
	local dataCount = #GupPet_SavedData["Companion"][ selectedBookType ] ;
	local temp_i = 0 ; 
	local dataFrame = _G["GupPet_InterfaceFrameCompanionMain".."CompanionList".."Data"] ;
	
	if not dataFrame.createdFrames then dataFrame.createdFrames   = 0 ;  end 
	
	for i=1 , dataCount do
	
		if GupPet_SavedOptions["Style"] == "CheckBox" then
			-- CheckBox
			if dataFrame.createdFrames < i then
			
				dataFrame[i] = CreateFrame("CheckButton", "$parent"..i , dataFrame , "GupPet_InterfaceCheckButtonTemplate");
				dataFrame[i].Index = i ;
				dataFrame[i]:SetScript("OnClick", function (self) GupPet_InterfaceFrameCompanion_MainCompanionList_OnChange(self.Index , self:GetChecked() ); end ) ;
				dataFrame[i]:SetScript("OnLeave", function() _G["GupPet_InterfaceFrameCompanionPreview"]:Hide(); 	end);	
			end
			
			dataFrame[i]:SetChecked(  GupPet_SavedData["Companion"][ selectedBookType ][i]["Weight"][ selected["ID"] ]     );
		else
			-- Slider
			if dataFrame.createdFrames < i then
				
				dataFrame[i] = CreateFrame("Slider", "$parent"..i , dataFrame , "GupPet_InterfaceSliderTemplate");
				dataFrame[i].Index = i ;
				
				dataFrame[i]:SetMinMaxValues(0 , 10);
				dataFrame[i]:SetValueStep(1) ;
			
				dataFrame[i]:SetScript("OnValueChanged", function (self) GupPet_InterfaceFrameCompanion_MainCompanionList_OnChange(self.Index , self:GetValue() );    end );
				dataFrame[i]:SetScript("OnLeave", function() _G["GupPet_InterfaceFrameCompanionPreview"]:Hide(); 	end);	
			end
			
			dataFrame[i]:SetValue(	GupPet_SavedData["Companion"][ selectedBookType ][i]["Weight"][selected["ID"] ] 	);
						
		end	
			
		dataFrame[i]:SetScript("OnEnter", function(self) _G["GupPet_InterfaceFrameCompanionPreviewModel"]:SetCreature(GupPet_SavedData["Companion"][ selectedBookType ][i]["CreatureID"]);	_G["GupPet_InterfaceFrameCompanionPreview"]:Show(); 	end);
		dataFrame[i]["text"]:SetText( GupPet_SavedData["Companion"][ selectedBookType ][i]["Name"]  ) ; 
		
		-- Generate 2 tables
		if i <= math.ceil( dataCount/2)  then
			dataFrame[i]:SetPoint('TOPLEFT', 10, 15-(i*15));
		else
			local z = i - math.ceil( dataCount/2) ;
			dataFrame[i]:SetPoint('TOPLEFT', 236, 15-(z*15));
		end
		
		--Show
		dataFrame[i]:Show() ;
				
		temp_i = i ;
	end
	
	-- Hide unneedid buttons
	for q = 1 ,dataFrame.createdFrames-temp_i do
		z = q + temp_i ;
		dataFrame[z]:Hide() ;
	end
	
	-- If created more frames save that number;
	if temp_i > dataFrame.createdFrames then
		dataFrame.createdFrames = temp_i; 
	end
	
	--
	GupPet_Interface_ScrollFrame_Update( _G["GupPet_InterfaceFrameCompanionMain".."CompanionList".."Container"] , math.ceil(dataCount/2) , math.floor((listHeight-10)/15) ,15 , 440);
	
	
end



----------------------------------------------------------------------------------------------------------------
--[[ 	GupPet_InterfaceFrameCompanion_MainCompanionList_OnChange												]]--
----------------------------------------------------------------------------------------------------------------
function GupPet_InterfaceFrameCompanion_MainCompanionList_OnChange( index , weight )
	
	-- Selected ID and bookType
	local selected = GupPet_InterfaceLocationList_GetSelected();
	local selectedBookType = GupPet_InterfaceCompanion_Tabs_GetSelectedBookType();

	if weight == nil or weight == false then
		weight = 0 ;
	end
	
	GupPet_DataHandler_SetCompanionWeight( selectedBookType , index , selected["ID"] , weight  );
	GupPet_Mount_RemoveCache( selected["ID"]  , selectedBookType  ) ;
	
end


---------
---------
---------

----------------------------------------------------------------------------------------------------------------
--[[ 	GupPet_InterfaceCompanion_Tabs_GetSelectedBookType													]]--
----------------------------------------------------------------------------------------------------------------
function GupPet_InterfaceCompanion_Tabs_GetSelectedBookType()
	
	local nrOffTabs = 5 ;
	
	for i=1 , nrOffTabs do
		local Tab = _G["GupPet_InterfaceFrameCompanionTab"..i];
		if not Tab:IsEnabled() then
			return Tab.bookType ;
		end
	end
end

----------------------------------------------------------------------------------------------------------------
--[[ 	GupPet_InterfaceCompanion_Tabs_Update																	]]--
----------------------------------------------------------------------------------------------------------------
function GupPet_InterfaceCompanion_Tabs_Update()

-- Check what buttons need to be hidden. or Unhidden as you cant unlearn 
	local tabIndex = 1;

	if #GupPet_SavedData["Companion"]["AquaticMount"] > 0 then
		local Tab = _G["GupPet_InterfaceFrameCompanionTab"..tabIndex];
		Tab.bookType = "AquaticMount";		
		Tab:SetText( GUPPET_L["AQUATICMOUNTTAB"] );
		Tab:Show();

		if not Tab.onIndex then Tab.onIndex = 1; end
		tabIndex = tabIndex+1;
	end

	if #GupPet_SavedData["Companion"]["GroundMount"] > 0 then
		local Tab = _G["GupPet_InterfaceFrameCompanionTab"..tabIndex];
		Tab.bookType = "GroundMount";		
		Tab:SetText( GUPPET_L["GROUNDMOUNTTAB"] );
		Tab:Show();

		if not Tab.onIndex then Tab.onIndex = 1; end
		tabIndex = tabIndex+1;
	end
	
	if #GupPet_SavedData["Companion"]["FlyMount"] > 0 then
		local Tab = _G["GupPet_InterfaceFrameCompanionTab"..tabIndex];
		Tab.bookType = "FlyMount";		
		Tab:SetText( GUPPET_L["FLYMOUNTTAB"] );
		Tab:Show();
		
		if not Tab.onIndex then Tab.onIndex = 1; end
		tabIndex = tabIndex+1;
	end
	
	if #GupPet_SavedData["Companion"]["MultiMount"] > 0 then
		local Tab = _G["GupPet_InterfaceFrameCompanionTab"..tabIndex];
		Tab.bookType = "MultiMount";		
		Tab:SetText( GUPPET_L["MULTIMOUNTTAB"] );
		Tab:Show();
		
		if not Tab.onIndex then Tab.onIndex = 1; end
		tabIndex = tabIndex+1;
	end
	
	if #GupPet_SavedData["Companion"]["Critter"] > 0 then
		if tabIndex > 1 then tabIndex = 5 ; end 
		
		local Tab = _G["GupPet_InterfaceFrameCompanionTab"..tabIndex];
		Tab.bookType = "Critter";		
		Tab:SetText( GUPPET_L["COMPANIONTAB"] );
		Tab:Show();
		
		if not Tab.onIndex then Tab.onIndex = 1; end
		tabIndex = tabIndex+1;
	end

end
---------
---------
---------

function GupPet_InterfaceCompanion_LocationFrame_Update()
	-- Update is addding or deleting of a location.
	
	local dataFrame = _G[ "GupPet_InterfaceFrame".."Companion".."Location".."Data"];
	local nrOffLocations = #GupPet_SavedData["Locations"] ;

	if not dataFrame.Total then dataFrame.Total = 0 ; end
	
	for i=1 , nrOffLocations do 
	
		if i > dataFrame.Total then
			dataFrame[ i ] = CreateFrame("Button", "GupPet_InterfaceFrameCompanionLocationData"..i  ,  dataFrame , "GupPet_InterfaceLocationListTemplate");
		end
	
		dataFrame[ i ].text:SetText( GupPet_SavedData["Locations"][i]["Name"]    );
		dataFrame[ i ].ID = GupPet_SavedData["Locations"][i]["ID"]
		dataFrame[ i ].Index = i ;
		dataFrame[i ]:Show() ;
		
		-- Set text Color 
		if GupPet_SavedData["Locations"][i]["Type"] == 0 or  GupPet_SavedData["Locations"][i]["Type"] == 10 
			or  GupPet_SavedData["Locations"][i]["Type"] == 20 or  GupPet_SavedData["Locations"][i]["Type"] == 30 or  GupPet_SavedData["Locations"][i]["Type"] == 40 then
			dataFrame[ i ].text:SetTextColor(1,0.82,0);
			dataFrame[ i ]:SetPoint("TOPLEFT", 5, 15 - (i*20) );
		else
			dataFrame[ i ].text:SetTextColor(1,1,1);
			dataFrame[ i ]:SetPoint("TOPLEFT", 20, 15 - (i*20) );
		end
		
		-- Update created buttons
		if i > dataFrame.Total then dataFrame.Total = i end
	end
	
	-- Hide unneedid buttons
	for q = 1 ,dataFrame.Total - nrOffLocations do
		z = q + nrOffLocations ;
		dataFrame[z]:Hide() ;
	end
	
	
	
	-- Update scroller
	GupPet_Interface_ScrollFrame_Update( _G["GupPet_InterfaceFrame".."Companion".."Location" .. "Container"] , nrOffLocations ,20 ,20 , 190-10);
	
end



function GupPet_InterfaceLocationList_OnClick(self)

	if  IsModifiedClick()  then   
		local selected = GupPet_InterfaceLocationList_GetSelected();
		
		GupPet_DataHandler_ToggleLinkLocationByIndex( selected["Index"] , self.Index ) ;
		
		--Update the ID's
		GupPet_InterfaceCompanion_LocationFrame_Update();
		
		--Set Highlights
		GupPet_InterfaceCompanion_LocationFrame_UpdateHighlight();
	else
		GupPet_InterfaceLocatinList_SetSelected( self.Index ) ;
	end
	
end


function GupPet_InterfaceLocatinList_SetSelected( selectedIndex )

	local dataFrame = _G[ "GupPet_InterfaceFrame".."Companion".."Location".."Data"];
	dataFrame.SelectedID = GupPet_SavedData["Locations"][ selectedIndex]["ID"] ;
	dataFrame.SelectedIndex = selectedIndex;
	dataFrame.SelectedName = GupPet_SavedData["Locations"][ selectedIndex]["Name"] ; 
	

-- So after this is calles we can update the mountframes etc.

	 GupPet_InterfaceCompanion_LocationFrame_UpdateHighlight() ;
	 GupPet_InterfaceCompanion_MainFrame_Update() ;
end

function GupPet_InterfaceLocationList_GetSelected()
	local dataFrame = _G[ "GupPet_InterfaceFrame".."Companion".."Location".."Data"];
	
	return { ID = dataFrame.SelectedID , Index = dataFrame.SelectedIndex , Name = dataFrame.SelectedName   } ;

end


function GupPet_InterfaceCompanion_LocationFrame_UpdateHighlight()

	--Highlight is different if the are grped
	local dataFrame = _G[ "GupPet_InterfaceFrame".."Companion".."Location".."Data"];
	local nrOffLocations = #GupPet_SavedData["Locations"] ;
	
	
	for i=1 , nrOffLocations do 
		
		if dataFrame[i].Index == dataFrame.SelectedIndex then
			dataFrame[i]:LockHighlight() ;
			dataFrame[i].highlight:SetVertexColor(.196, .388, .8);
		elseif dataFrame[i].ID == dataFrame.SelectedID then
			dataFrame[i]:LockHighlight() ;
			dataFrame[i].highlight:SetVertexColor(1, 1, .0);
		else
			dataFrame[i]:UnlockHighlight();
			dataFrame[i].highlight:SetVertexColor(.196, .388, .8);
		end
	
	end
	
	
	--[[
		if not( GUPPET_INTERFACE_SAVEHIGHLIGHT[Type] == nil) then
		_G[ GUPPET_INTERFACE_SAVEHIGHLIGHT[Type] ]:UnlockHighlight();
	end
	
	Button:LockHighlight() ;
	GUPPET_INTERFACE_SAVEHIGHLIGHT[Type] = Button:GetName();
	]]
	

end





----------------------------------------------------------------------------------------------------------------
--[[	GupPetet_Interface_MinimapButton_Init																	]]--
----------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------
function GupPet_InterfaceMinimapButton_Update()
	
	if GupPet_SavedOptions["MinimapButton"]["Show"] then
		_G["GupPet_MinimapButton"]:Show() ;
	else
		_G["GupPet_MinimapButton"]:Hide() ;
	end

	GupPet_InterfaceMinimapButton_UpdatePosition() ;
end

----------------------------------------------------------------------------------------------------------------
--[[	GupPetet_Interface_MinimapButton_UpdatePosition														]]--
----------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------
function GupPet_InterfaceMinimapButton_UpdatePosition()

	_G["GupPet_MinimapButton"]:SetPoint("TOPLEFT","Minimap","TOPLEFT",54 - (GupPet_SavedOptions["MinimapButton"]["Radius"] * cos(GupPet_SavedOptions["MinimapButton"]["Position"])),(GupPet_SavedOptions["MinimapButton"]["Radius"] * sin(GupPet_SavedOptions["MinimapButton"]["Position"])) - 55	);
	
end

----------------------------------------------------------------------------------------------------------------
--[[	GupPetet_Interface_MinimapButton_OnDrag																]]--
----------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------
function GupPet_InterfaceMinimapButton_OnDrag()

	local xpos,ypos = GetCursorPosition() ;
	local xmin,ymin = Minimap:GetLeft(), Minimap:GetBottom() ;

	xpos = xmin-xpos/UIParent:GetScale()+70 ;
	ypos = ypos/UIParent:GetScale()-ymin-70 ;

	local v = math.deg(math.atan2(ypos, xpos)) ;
	if v < 0 then
		v = v + 360 ;
	end
	GupPet_SavedOptions["MinimapButton"]["Position"] = v ;
	
	
	GupPet_InterfaceMinimapButton_UpdatePosition() ;

end






----------------------------------------------------------------------------------------------------------------
--[[	GupPetet_IconPopupFrame_Update																		
----------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------
function GupPetet_IconPopupFrame_Update(self)
	self = self or GupPetet_IconPopupFrame;
	local numIcons = GetNumMacroIcons();
	local PopupIcon, PopupButton;
	local PopupOffset = FauxScrollFrame_GetOffset(GupPetet_IconPopupScrollFrame);
	local index;
	
	local texture;
	for i=1, 20 do
		PopupIcon = _G["GupPetet_IconPopupButton"..i.."Icon"];
		PopupButton = _G["GupPetet_IconPopupButton"..i];
		index = (PopupOffset * 5) + i;
		texture = GetMacroIconInfo(index);
		if ( index <= numIcons ) then
			PopupIcon:SetTexture(texture);
			PopupButton:Show();
		else
			PopupIcon:SetTexture("");
			PopupButton:Hide();
		end

		if (GupPetet_IconPopupFrame.selectedIconTexture ==  texture ) then
			PopupButton:SetChecked(1);
		else
			PopupButton:SetChecked(nil);
		end
	end
	
	FauxScrollFrame_Update(GupPetet_IconPopupScrollFrame, ceil(numIcons / 5) , 4, 36 );
end

----------------------------------------------------------------------------------------------------------------
	GupPetet_IconPopupButton_SelectTexture																
----------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------
function GupPetet_IconPopupButton_SelectTexture(selectedIcon)
	GupPetet_IconPopupFrame.selectedIconTexture = GetMacroIconInfo(selectedIcon);
	
	if GupPetet_Interface_GetSelected( "IconTabs" ) == "GupPetet_IconPopupFrameTab1" then
		GupPet_SavedOptions.IngameButton.Icons.Ground =  GupPetet_IconPopupFrame.selectedIconTexture ;
	elseif GupPetet_Interface_GetSelected( "IconTabs" ) == "GupPetet_IconPopupFrameTab2" then
		GupPet_SavedOptions.IngameButton.Icons.Fly =  GupPetet_IconPopupFrame.selectedIconTexture ;
	elseif GupPetet_Interface_GetSelected( "IconTabs" ) == "GupPetet_IconPopupFrameTab3" then
		GupPet_SavedOptions.IngameButton.Icons.Auto =  GupPetet_IconPopupFrame.selectedIconTexture ;
	elseif GupPetet_Interface_GetSelected( "IconTabs" ) == "GupPetet_IconPopupFrameTab4" then
		GupPet_SavedOptions.IngameButton.Icons.Companion =  GupPetet_IconPopupFrame.selectedIconTexture ;
	end
	
	GupPetet_Interface_IngameButtons_UpdateIcons()
end

----------------------------------------------------------------------------------------------------------------
	GupPetet_IconPopupButton_OnClick																	
----------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------
function GupPetet_IconPopupButton_OnClick(self, button)
	GupPetet_IconPopupButton_SelectTexture(self:GetID() + (FauxScrollFrame_GetOffset(GupPetet_IconPopupScrollFrame) * 5));
	GupPetet_IconPopupFrame_Update();
end

----------------------------------------------------------------------------------------------------------------
	GupPetet_IconPopupFrame_TabClick																		
----------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------
function GupPetet_IconPopupFrame_TabClick()

	if GupPetet_Interface_GetSelected( "IconTabs" ) == "GupPetet_IconPopupFrameTab1" then
		GupPetet_IconPopupFrame.selectedIconTexture  = GupPet_SavedOptions.IngameButton.Icons.Ground ;
	elseif GupPetet_Interface_GetSelected( "IconTabs" ) == "GupPetet_IconPopupFrameTab2" then
		GupPetet_IconPopupFrame.selectedIconTexture  = GupPet_SavedOptions.IngameButton.Icons.Fly ;
	elseif GupPetet_Interface_GetSelected( "IconTabs" ) == "GupPetet_IconPopupFrameTab3" then
		GupPetet_IconPopupFrame.selectedIconTexture  = GupPet_SavedOptions.IngameButton.Icons.Auto ;
	elseif GupPetet_Interface_GetSelected( "IconTabs" ) == "GupPetet_IconPopupFrameTab4" then
		GupPetet_IconPopupFrame.selectedIconTexture  = GupPet_SavedOptions.IngameButton.Icons.Companion ;
	end
	
	GupPetet_IconPopupFrame_Update();
end

----------------------------------------------------------------------------------------------------------------
--	GupPetet_IconPopupFrame_CloseEdit																		
----------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------
function GupPetet_IconPopupFrame_CloseEdit()
	GupPetet_IconPopupFrame:Hide();
end

----------------------------------------------------------------------------------------------------------------
	GupPetet_IconPopupFrame_RestoreEdit																
----------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------
function GupPetet_IconPopupFrame_RestoreEdit()

	GupPet_SavedOptions.IngameButton.Icons = { 	Ground = "Interface\\Icons\\Ability_Mount_Mammoth_Black" , 
											Fly = "Interface\\Icons\\Ability_Mount_Drake_Bronze" , 
											Auto = "Interface\\Icons\\Ability_Mount_Drake_Azure" , 
											Companion = "Interface\\Icons\\INV_Box_PetCarrier_01" }
	GupPetet_Interface_IngameButtons_UpdateIcons()
	GupPetet_IconPopupFrame_Update();
end

----------------------------------------------------------------------------------------------------------------
	GupPetet_IconPopupFrame_OnShow																	
----------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------
function GupPetet_IconPopupFrame_OnShow(self)

	PlaySound("igCharacterInfoOpen");
	GupPetet_IconPopupFrame_TabClick();
	GupPetet_IconPopupFrame_Update(self);
end
]]

----------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------

GupPet_Interface_TempTabData = {} ;

----------------------------------------------------------------------------------------------------------------
--[[ 	GupPet_Interface_AddTab																				]]--
----------------------------------------------------------------------------------------------------------------
function GupPet_Interface_AddTab( self , tabFrame )

	local tabGroup = self.tabGroup ;

	-- Create the Tab Group
	if not GupPet_Interface_TempTabData[tabGroup] then
		GupPet_Interface_TempTabData[tabGroup] = {} ;
	end

	tinsert( GupPet_Interface_TempTabData[tabGroup] , { self:GetName()  ,tabFrame} ) ;
			
end

----------------------------------------------------------------------------------------------------------------
--[[ 	GupPet_Interface_ShowTab																				]]--
----------------------------------------------------------------------------------------------------------------
function GupPet_Interface_ShowTab( self )

	local tabName = self:GetName();
	local tabGroup = self.tabGroup ;

	for i=1 , #GupPet_Interface_TempTabData[tabGroup] do
		
		if GupPet_Interface_TempTabData[tabGroup][i][1] == tabName then
			-- SET HIGHLIGHT
			GupPet_Interface_SelectTab(tabName)
			
			-- Show Frame
			local frame = _G[ GupPet_Interface_TempTabData[tabGroup][i][2]  ] ;
			if frame then frame:Show(); end
		else
			-- REMOVE HIGHLIGHT
			GupPet_Interface_DeselectTab( GupPet_Interface_TempTabData[tabGroup][i][1] ) ;
			
			--Hide Frames
			local frame = _G[ GupPet_Interface_TempTabData[tabGroup][i][2]  ] ;
			if frame then frame:Hide(); end
		end
	end

end

----------------------------------------------------------------------------------------------------------------
--[[ 	GupPet_Interface_DeselectTab																			]]--
----------------------------------------------------------------------------------------------------------------
function GupPet_Interface_DeselectTab(name)
	_G[name.."Left"]:Show();
	_G[name.."Middle"]:Show();
	_G[name.."Right"]:Show();
	_G[name]:Enable();
	_G[name.."LeftDisabled"]:Hide();
	_G[name.."MiddleDisabled"]:Hide();
	_G[name.."RightDisabled"]:Hide();
end

----------------------------------------------------------------------------------------------------------------
--[[ 	GupPet_Interface_SelectTab																			]]--
----------------------------------------------------------------------------------------------------------------
function GupPet_Interface_SelectTab(name)
	_G[name.."Left"]:Hide();
	_G[name.."Middle"]:Hide();
	_G[name.."Right"]:Hide();
	_G[name]:Disable();
	_G[name]:SetDisabledFontObject(GameFontHighlightSmall);
	_G[name.."LeftDisabled"]:Show();
	_G[name.."MiddleDisabled"]:Show();
	_G[name.."RightDisabled"]:Show();
	
	if ( GameTooltip:IsOwned(_G[name]) ) then
		GameTooltip:Hide();
	end
end


----------------------------------------------------------------------------------------------------------------
--[[	GupPet_Interface_ScrollFrame_Update																	]]--
----------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------
function GupPet_Interface_ScrollFrame_Update(frame, numItems, numToDisplay, valueStep , FrameWidth  )

	local frameName = frame:GetName();
	local scrollBar = _G[ frameName.."ScrollBar"];
	local scrollChildFrame = _G[ frameName.."ScrollChildFrame"];
	local scrollUpButton = _G[ frameName.."ScrollBarScrollUpButton"];
	local scrollDownButton = _G[ frameName.."ScrollBarScrollDownButton"];
	local scrollFrameHeight = 0;
	local scrollChildHeight = 0;

	if ( numItems > 0 ) then
		scrollFrameHeight = (numItems - numToDisplay) * valueStep;
		scrollChildHeight = numItems * valueStep;
		if ( scrollFrameHeight < 0 ) then
			scrollFrameHeight = 0;
		end
		scrollChildFrame:Show();
	else
		scrollChildFrame:Hide();
	end

	scrollBar:SetMinMaxValues(0, scrollFrameHeight); 
	scrollBar:SetValueStep(valueStep);
	scrollChildFrame:SetHeight(scrollChildHeight);
	
	if ( numItems > numToDisplay ) then
		scrollBar:Show();
		frame:SetWidth(FrameWidth-22) ;
	else
		frame:SetWidth(FrameWidth);
		scrollBar:Hide();
	end

	-- Arrow button handling
	if ( scrollBar:GetValue() == 0 ) then
		scrollUpButton:Disable();
	else
		scrollUpButton:Enable();
	end
		
	if ((scrollBar:GetValue() - scrollFrameHeight) == 0) then
		scrollDownButton:Disable();
	else
		scrollDownButton:Enable();
	end

end
