
---RENAME TO USER
GupPet_TempUserData = { CanFlyContinentNorthrend=false ,CanFlyContinentVanilla=false  } ;

--------------------------------------------------------------------------------------------------------------
-- GupPet_User_UpdateSpellBookData																			--
--------------------------------------------------------------------------------------------------------------
function GupPet_User_UpdateSpellBookData()

	--Check flyspells
	local spellname = GetSpellInfo( 54197 ) ;
	GupPet_TempUserData["CanFlyContinentNorthrend"] = IsUsableSpell(spellname);
	
	spellname = GetSpellInfo( 90267 ) ; --EDDIT TO VAnilla  Flight Master's License
	GupPet_TempUserData["CanFlyContinentVanilla"] = IsUsableSpell(spellname);
	--
	
	--Class
	_, GupPet_TempUserData.UnitClass = UnitClass("player") ;
	
	
	---------------------------------
	GupPet_TempUserData["classAquaticUsable"] = false ;
	GupPet_TempUserData["classGroundUsable"] = false ;
	GupPet_TempUserData["classFlyUsable"] = false ;
	---------------------------------
	if GupPet_TempUserData.UnitClass == "HUNTER" then
		
		GupPet_TempUserData["Pack"]  	= GupPet_User_IsInBook( GupPet_ClassData.HUNTER.Pack ) ;
		GupPet_TempUserData["Cheetah"] = GupPet_User_IsInBook( GupPet_ClassData.HUNTER.Cheetah ) ;
		
		GupPet_TempUserData["classGroundUsable"] = GupPet_TempUserData["Pack"]["Usable"] or  GupPet_TempUserData["Cheetah"]["Usable"] ;
	
	elseif GupPet_TempUserData.UnitClass == "DRUID" then
	
		GupPet_TempUserData["Travel"]  = GupPet_User_IsInBook( GupPet_ClassData.DRUID.Travel ) ;
		GupPet_TempUserData["SlowFly"] = GupPet_User_IsInBook( GupPet_ClassData.DRUID.SlowFly ) ;
		GupPet_TempUserData["FastFly"] = GupPet_User_IsInBook( GupPet_ClassData.DRUID.FastFly ) ;
		GupPet_TempUserData["Aquatic"] = GupPet_User_IsInBook( GupPet_ClassData.DRUID.Aquatic ) ;
		GupPet_TempUserData["Cat"]  	= GupPet_User_IsInBook( GupPet_ClassData.DRUID.Cat ) ;
		
		GupPet_TempUserData["classAquaticUsable"] = GupPet_TempUserData["Aquatic"]["Usable"] ;
		GupPet_TempUserData["classGroundUsable"] = GupPet_TempUserData["Cat"]["Usable"] or  GupPet_TempUserData["Travel"]["Usable"] ;
		GupPet_TempUserData["classFlyUsable"] = GupPet_TempUserData["SlowFly"]["Usable"] or  GupPet_TempUserData["FastFly"]["Usable"] ;
	
	elseif GupPet_TempUserData.UnitClass == "SHAMAN" then
		
		GupPet_TempUserData["Ghost"] = GupPet_User_IsInBook( GupPet_ClassData.SHAMAN.Ghost ) ;
		GupPet_TempUserData["WaterWalking"] = GupPet_User_IsInBook( GupPet_ClassData.SHAMAN.WaterWalking ) ;
		
		GupPet_TempUserData["classGroundUsable"]  = GupPet_TempUserData["Ghost"]["Usable"];
		
	elseif GupPet_TempUserData.UnitClass == "MAGE" then
	
		GupPet_TempUserData["SlowFall"]  = GupPet_User_IsInBook( GupPet_ClassData.MAGE.SlowFall ) ;
		GupPet_TempUserData["Blink"]  = GupPet_User_IsInBook( GupPet_ClassData.MAGE.Blink ) ;
		
		GupPet_TempUserData["classGroundUsable"]  = GupPet_TempUserData["Blink"]["Usable"] ;
		
	elseif GupPet_TempUserData.UnitClass == "DEATHKNIGHT" then
	
		GupPet_TempUserData["PathOfFrost"]  = GupPet_User_IsInBook( GupPet_ClassData.DEATHKNIGHT.PathOfFrost ) ;
		
	elseif GupPet_TempUserData.UnitClass == "WORGEN" then
		GupPet_TempUserData["RunningWild"]  = GupPet_User_IsInBook( GupPet_ClassData.WORGEN.RunningWild ) ;
		
		GupPet_TempUserData["classGroundUsable"]  = GupPet_TempUserData["RunningWild"]["Usable"];
	end
	
	------ 
	GupPet_TempUserData["SpiritOfRedemption"] = {} ;
	GupPet_TempUserData["FeignDeath"] = {} ;
	GupPet_TempUserData["Invisibility"] = {} ;
	GupPet_TempUserData["SpiritOfRedemption"]["Name"]  = GetSpellInfo( GupPet_ClassData.PRIEST.SpiritOfRedemption ) ;
	GupPet_TempUserData["FeignDeath"]["Name"]  = GetSpellInfo( GupPet_ClassData.HUNTER.FeignDeath ) ;
	GupPet_TempUserData["Invisibility"]["Name"]  = GetSpellInfo( GupPet_ClassData.MAGE.Invisibility ) ;
	------
	
	
	-- CHECK IF YOU ARE A GOBLIN AND HAVE THE HOTRODKEYS
	
	
	
end


--------------------------------------------------------------------------------------------------------------
--	GupPet_User_IsInBook				 																			--
--------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------
function GupPet_User_IsInBook( spell )
	
	local tempvar = { Usable = false }
	
	tempvar.Name = GetSpellInfo(spell) ;
	tempvar.Spell = spell ;
	local slot = 1 ;
	
	while GetSpellBookItemName(slot, "spell") do
		local name = GetSpellBookItemName(slot, "spell") ;
		if name == tempvar.Name then
			
			tempvar.Usable = true
			return tempvar
		end 
		slot = slot + 1 ;
	end 

	return tempvar
end



function GupPet_User_BuildCombatMacro()

	
	if GupPet_TempUserData.UnitClass  == "DRUID" then
		--[[		
				local BuildMacro = "/use "

				if GupPetet_TempClassData["Aquatic"]["Usable"] then
					BuildMacro = BuildMacro .."[swimming,nomounted] "..GupPetet_TempClassData["Aquatic"]["Name"] ..";"
				end
				
				if GupPetet_TempClassData["Travel"]["Usable"] then
					BuildMacro = BuildMacro .."[outdoors,nomounted] "..GupPetet_TempClassData["Travel"]["Name"] ..";"
				end
				
				if GupPetet_TempClassData["Cat"]["Usable"] and GupPetet_SavedOptions["Class"]["CatOnIndoors"] then
					BuildMacro = BuildMacro .."[indoors,nomounted] "..GupPetet_TempClassData["Cat"]["Name"] ..";"
				end
				
				BuildMacro = BuildMacro .."\n/script GupPetet_Exit()" ;
				
				_G["GupPetet_IngameFrameTemplateAuto"]:SetAttribute("macrotext", BuildMacro );
				_G["GupPetet_IngameFrameTemplateAuto"]:SetAttribute("shift-macrotext1", BuildMacro );
				_G["GupPetet_IngameFrameTemplateGround"]:SetAttribute("macrotext", BuildMacro );
				_G["GupPetet_IngameFrameTemplateGround"]:SetAttribute("shift-macrotext1", BuildMacro );
	]]
	
	elseif GupPet_TempUserData.UnitClass == "SHAMAN" then
		
		if GupPet_TempUserData["Ghost"]["Usable"] then
			_G["GupPet_IngameButtonFrameAuto"]:SetAttribute("macrotext", "/use [nomounted] "..GupPet_TempUserData["Ghost"]["Name"] .."\n/script GupPet_Exit()")
			_G["GupPet_IngameButtonFrameGround"]:SetAttribute("macrotext", "/use [nomounted] "..GupPet_TempUserData["Ghost"]["Name"] .."\n/script GupPet_Exit()")
		end
		
	elseif GupPet_TempUserData.UnitClass == "MAGE" then
		
		if GupPetet_SavedOptions["Class"]["SlowFallOnFalling"] and GupPet_TempUserData["SlowFall"]["Usable"] then
			_G["GupPet_IngameButtonFrameAuto"]:SetAttribute("macrotext", "/use [nomounted] "..GupPet_TempUserData["SlowFall"]["Name"] .."\n/script GupPet_Exit()")
			_G["GupPet_IngameButtonFrameGround"]:SetAttribute("macrotext", "/use [nomounted] "..GupPet_TempUserData["SlowFall"]["Name"] .."\n/script GupPet_Exit()")
		end
		
	else
		--self:UnregisterEvent("PLAYER_REGEN_DISABLED");
	end


end


