GUPPET_L = {} ;


-- For the key bind interface
BINDING_HEADER_GUPPET = "GupPet";
BINDING_NAME_GUPPET_AUTOMOUNT = "Auto select mount";
BINDING_NAME_GUPPET_FLYMOUNT = "Fly mount";
BINDING_NAME_GUPPET_GROUNDMOUNT = "Ground mount";
BINDING_NAME_GUPPET_AQUATICMOUNT = "Aquatic mount";
BINDING_NAME_GUPPET_MULTIMOUNT = "Multi mount";
BINDING_NAME_GUPPET_CRITTER = "Summon companion";


-- Slash Commands
GUPPET_L["SLASH"] = "The start command is '/GP' or '/GupPet'. ( The slashcommands in GupPet dont support shapeshift abilities. )" ;
GUPPET_L["USE"] = " or " ;
	
GUPPET_L["SLASH_S_MM"] = "mm";
GUPPET_L["SLASH_B_MM"] = "multimount";
GUPPET_L["SLASH_T_MM"] = "Selects a random multi mount";
	
GUPPET_L["SLASH_S_AQM"] = "aqm";
GUPPET_L["SLASH_B_AQM"] = "aquaticmount";
GUPPET_L["SLASH_T_AQM"] = "Selects a random aquatic mount";

GUPPET_L["SLASH_S_GM"] = "gm";
GUPPET_L["SLASH_B_GM"] = "groundmount";
GUPPET_L["SLASH_T_GM"] = "Selects a random ground mount";

GUPPET_L["SLASH_S_FM"] = "fm";
GUPPET_L["SLASH_B_FM"] = "flymount";
GUPPET_L["SLASH_T_FM"] = "Selects a random fly mount";

GUPPET_L["SLASH_S_AM"] = "am";
GUPPET_L["SLASH_B_AM"] = "automount";
GUPPET_L["SLASH_T_AM"] = "Selects a random mount depending on the location and settings";
	
GUPPET_L["SLASH_S_CC"] = "cc";
GUPPET_L["SLASH_B_CC"] = "callcompanion";
GUPPET_L["SLASH_T_CC"] = "Selects a random companion";
		
GUPPET_L["SLASH_S_OM"] = "om";
GUPPET_L["SLASH_B_OM"] = "optionmenu";
GUPPET_L["SLASH_T_OM"] = "Shortcut to the optionmenu"


-- Texts for chat
GUPPET_L["UNKNOWNMOUNTFOUND"] = "An unknown mount has been found.  Please report this so that it can be added to future versions.";
GUPPET_L["NEWVERSIONFOUND"] = "A NEW version has been found. The new version is v." ;
GUPPET_L["UNKNOWNSLASHCOMMAND"] = "|cffee4400 The slashcommand you entered is not correct. Check the optionmenu for the correct one. |r ( /GupPet om )";

GUPPET_L["CANTCALLCRITTER"] = "No companion can be called ( None Enabled )" ;
GUPPET_L["CANTCALLCRITTERNOSNOWBALL"] = "No companion can be called. All enabled use snowballs and you have none with you." ;
GUPPET_L["CANTCALLCRITTERNONEINTHETABLE"] = "Only one companion is in the random rotation and is already out.";

GUPPET_L["CANTCALLMULTIDMOUNT"] = "No multi mount can be called ( None Enabled )" ;
GUPPET_L["CANTCALLGROUNDMOUNT"] = "No ground mount can be called ( None Enabled )" ;
GUPPET_L["CANTCALLFLYMOUNT"] = "No fly mount can be called ( None Enabled )" ;
GUPPET_L["CANTCALLAQUATICMOUNT"] = "No aquatic mount can be called ( None Enabled )" ;


-- Tabs
GUPPET_L["ADDTABTOOLTIP"]		= "Adds the current location";
GUPPET_L["REMOVETABTOOLTIP"]	= "Removes the selected location" ;

GUPPET_L["OPTIONTAB"] = "Options";
GUPPET_L["MOUNTS_CRITTERTAB"]	= "Mounts + Companions";
GUPPET_L["CLASSTAB"] = "Class";
GUPPET_L["CLOSETAB"] = "Close";
GUPPET_L["HELP_ABOUTTAB"] = "Help + About";

GUPPET_L["AQUATICMOUNTTAB"]	= "Aquatic" ;
GUPPET_L["GROUNDMOUNTTAB"]	= "Ground" ;
GUPPET_L["FLYMOUNTTAB"]		= "Fly" ;
GUPPET_L["MULTIMOUNTTAB"]		= "Multi" ;
GUPPET_L["COMPANIONTAB"]		= "Companion" ;

-- Buttons
GUPPET_L["ENABLEBUTTON"] = "Enable";
GUPPET_L["DISABLEBUTTON"] = "Disable";

GUPPET_L["USEFLYASGROUND"] = "Force flying mount";
GUPPET_L["USEFLYASGROUNDTOOLTIP"] = "On this location use a flying mount as ground";
GUPPET_L["USEFLYASGROUNDTOOLTIPR"] = "(This is setting stayes unique even when you link the locations)";


--Menu 
GUPPET_L["INGAMEBUTTONFRAME"] = "Ingame Buttons";
GUPPET_L["INGAMEBUTTONFRAME_SHOW"] = "Show";
GUPPET_L["INGAMEBUTTONFRAME_LOCKED"] = "Locked";
GUPPET_L["INGAMEBUTTONFRAME_RESTORE"]	= "Restore" ;
GUPPET_L["INGAMEBUTTONFRAME_RESTORETOOLTIP"]	= "Restore the position of the actionbuttons to the center of the screen" ;
GUPPET_L["INGAMEBUTTONFRAME_SCALE"] = "Scale";
GUPPET_L["INGAMEBUTTONFRAME_SCALELOW"] = "Small";
GUPPET_L["INGAMEBUTTONFRAME_SCALEHIGH"] = "Big";
GUPPET_L["INGAMEBUTTONFRAME_COMPANIONBUTTONSHOW"] = "Show companion button";
GUPPET_L["INGAMEBUTTONFRAME_ICON"] = "Icon";
GUPPET_L["INGAMEBUTTONFRAME_ICONTOOLTIP"] = "Show a menu to change the look of the buttons";
GUPPET_L["INGAMEBUTTONFRAME_MODE"] = "Mount button auto";
GUPPET_L["INGAMEBUTTONFRAME_MODETOOLTIP"] = "Change the amount of buttons from one to multiple";
GUPPET_L["INGAMEBUTTONFRAME_ALIGNMENT"] = "Alignment";
GUPPET_L["INGAMEBUTTONFRAME_ALIGNMENTTOOLTIP"] = "Toggle the button alignment from horizontal to vertical";
GUPPET_L["INGAMEBUTTONFRAME_HIDEKEYBINDTEXT"] = "Hide keybind" 
GUPPET_L["INGAMEBUTTONFRAME_HIDEKEYBINDTEXTTOOLTIP"] = "Hides the keybind text on the buttons when checked"

GUPPET_L["MINIMAPFRAME"] = "Minimap Button";
GUPPET_L["MINIMAPFRAME_SHOW"] = "Show";

GUPPET_L["AUTOCALLCOMPANIONFRAME"] = "Companion" ;
GUPPET_L["AUTOCALLCOMPANIONFRAME_ENABLE"] = "Enable Auto Call" ;
GUPPET_L["AUTOCALLCOMPANIONFRAME_CITY"] = "City" ;
GUPPET_L["AUTOCALLCOMPANIONFRAME_OUTSIDE"] = "Outside" ;
GUPPET_L["AUTOCALLCOMPANIONFRAME_ARENA"] = "Arena" ;
GUPPET_L["AUTOCALLCOMPANIONFRAME_PARTY"] = "Party" ;
GUPPET_L["AUTOCALLCOMPANIONFRAME_RAID"] = "Raid" ;
GUPPET_L["AUTOCALLCOMPANIONFRAME_BATTLEGROUND"] =  "BattleGround" ;
GUPPET_L["AUTOCALLCOMPANIONFRAME_DELAY"] =  "Delay" ;
GUPPET_L["AUTOCALLCOMPANIONFRAME_DELAYTOOLTIP"] = "The time the auto call function waits in seconds from 2 to 10";
GUPPET_L["AUTOCALLCOMPANIONFRAME_AUTODISMISSMOUNTED"] = "Dismiss while mounted";
GUPPET_L["AUTOCALLCOMPANIONFRAME_ENABLERESUMMON"] =  "Enable Recall Delay" ;
GUPPET_L["AUTOCALLCOMPANIONFRAME_RESUMMONDELAY"] = "Delay time";
GUPPET_L["AUTOCALLCOMPANIONFRAME_RESUMMONDELAYTOOLTIP"] = "The time the auto recall function waits in seconds to recall a companion.";
GUPPET_L["AUTOCALLCOMPANIONFRAME_RESUMMONCITYONLY"] = "Recall in City/Inn only";
GUPPET_L["AUTOCALLCOMPANIONFRAME_PETOFTHEDAY"] = "Enable 'Pet of the day'" ;	
GUPPET_L["AUTOCALLCOMPANIONFRAME_PETOFTHEDAYTOOLTIP"] = "Keeps summoning the same companion the entire day. (You can overrule it by pressing the ingame button or macro) "

GUPPET_L["PREVIEWFRAME"] 	= "Preview Screen" ;
GUPPET_L["PREVIEWFRAME_SPEED"] = "Rotate speed" ;
GUPPET_L["PREVIEWFRAME_SPEEDLOW"] = "-1";
GUPPET_L["PREVIEWFRAME_SPEEDHIGH"] = "1" ;
GUPPET_L["PREVIEWFRAME_STARTPOS"] = "Start position" ;
GUPPET_L["PREVIEWFRAME_STARTPOSLOW"] = "-180" ;
GUPPET_L["PREVIEWFRAME_STARTPOSHIGH"] = "180";

GUPPET_L["EXTRAFRAME"] = "Extra" ;
GUPPET_L["EXTRAFRAME_AUTODISMOUNT"] = "Auto dismount";
GUPPET_L["EXTRAFRAME_AUTODISMOUNTTOOLTIP"] = "Automatically dismount when you receive the 'You are mounted' error if you are not flying";
GUPPET_L["EXTRAFRAME_CHANGESTYLE"] = "Slider Style";
GUPPET_L["EXTRAFRAME_CHANGESTYLETOOLTIP"] = "Changes the checkboxes to sliders for more detailed settings";


-- Ingame Buttons
GUPPET_L["INGAMEBUTTONS_MOVETOOLTIP"] = "Move Buttons";
GUPPET_L["INGAMEBUTTONS_MOVETOOLTIPR"] = "Right Click to lock";

GUPPET_L["INGAMEBUTTONS_AUTOTOOLTIP"] = "Auto Select";
GUPPET_L["INGAMEBUTTONS_AUTOTOOLTIPR"] = " +Shift to force a ground type |n +Ctrl for a multi type";
GUPPET_L["INGAMEBUTTONS_AUTOTOOLTIPR_DRUID"] = " +Alt to use TravelFrom";
GUPPET_L["INGAMEBUTTONS_AUTOTOOLTIPR_SHAMAN"] = " +Alt to use GhostWolf";
GUPPET_L["INGAMEBUTTONS_AUTOTOOLTIPR_MAGE"] = " +Alt to Blink";

GUPPET_L["INGAMEBUTTONS_GROUNDTOOLTIP"] = "Auto Ground";
GUPPET_L["INGAMEBUTTONS_GROUNDTOOLTIPR"] = "";

GUPPET_L["INGAMEBUTTONS_FLYTOOLTIP"] = "Auto Fly";
GUPPET_L["INGAMEBUTTONS_FLYTOOLTIPR"] = "";

GUPPET_L["INGAMEBUTTONS_AQUATICTOOLTIP"] = "Auto Aquatic";
GUPPET_L["INGAMEBUTTONS_AQUATICTOOLTIPR"] = "";

GUPPET_L["INGAMEBUTTONS_CRITTERTOOLTIP"] = "Random Companion";
GUPPET_L["INGAMEBUTTONS_CRITTERTOOLTIPR"] = " +Shift to dismiss";

-- Locations
GUPPET_L["GLOBALWORLD"]   = "Global World" ;	
GUPPET_L["CITIES"]  		= "Cities" ;
GUPPET_L["INSTANCES"] 	= "Instances" ;
GUPPET_L["INSTANCE_AQ40"] = "Ahn'Qiraj" ;
GUPPET_L["ARENAS"]  		= "Arenas" ;
GUPPET_L["BATTLEGROUNDS"] = "BattleGrounds" ;


-- Popup
GUPPET_L["POPUP_REMOVE"] = "Are you sure you want to remove %s";
GUPPET_L["POPUP_REMOVEYES"] = "Yes";
GUPPET_L["POPUP_REMOVENO"] = "No"; 

GUPPET_L["POPUP_CHANGESTYLE"] = "This action requers a reload. Continue ?" ;
GUPPET_L["POPUP_CHANGESTYLEYES"] = "Yes";
GUPPET_L["POPUP_CHANGESTYLENO"] = "No";


--[[

	GUPPET_L["CLASS"]				= { "Class" , "" };
	
	GUPPET_L["INGAMEBUTTONS"]		= { "Ingame Buttons" , "" };
	
	GUPPET_L["DRUID_Fly"]		= { "Use Fly form" , "" };
	GUPPET_L["DRUID_Aquatic"]	= { "Use Aquatic form" , "" };
	GUPPET_L["DRUID_Travel"]	= { "Use Travel form while moving" , "" };
	GUPPET_L["DRUID_Cat"]		= { "Use Cat form while indoors" , "" };
	
	GUPPET_L["SHAMAN_Ghost"]	= { "Use GhostWolf while moving" , "" };
	GUPPET_L["SHAMAN_WaterWalking"]	= { "Use WaterWalking if swimming" , "" };
	
	GUPPET_L["MAGE_SlowFall"] 	= { "Use SlowFall if falling" , ""}
	
	GUPPET_L["DEATHKNIGHT_PathOfFrost"] 	= { "Use Path of Frost if swimming" , ""}
	 

	
]]